package xyz.thastertyn.Types;

import java.util.ArrayList;

public class Predmet {
	
	private ArrayList<Znamka> znamky = new ArrayList<>();
	private String jmenoPredmetu = "";
	private boolean isFinal = false;

	private int vyslednaZnamka = 0;

	public Predmet(String jmenoPredmetu)
	{
		this.jmenoPredmetu = jmenoPredmetu;
	}

	public Predmet(String jmenoPredmetu, int vyslednaZnamka)
	{
		this.jmenoPredmetu = jmenoPredmetu;
		this.vyslednaZnamka = vyslednaZnamka;
		isFinal = true;
	}

	public void addZnamka(Znamka novaZnamka)
	{
		znamky.add(novaZnamka);
	}

	public double getVyslednaZnamka()
	{
		if(vyslednaZnamka != 0)
		{
			return vyslednaZnamka;
		}
		
		if(znamky.isEmpty())
		{
			return 0;
		}

		int celkem = znamky
			.stream()
			.mapToInt((z) -> z.getZnamka() * z.getVaha())
			.sum();

		int vahy = znamky
			.stream()
			.mapToInt((z) -> z.getVaha())
			.sum();

		return (double) celkem / vahy;
	}

	public boolean isFinal()
	{
		return isFinal;
	}

	public String getJmenoPredmetu()
	{
		return jmenoPredmetu;
	}

	public ArrayList<Znamka> getZnamky()
	{
		return znamky;
	}
}
